//+---------------------------------------------------------------------+
//|                                                          T3MACO.mq5 | 
//|                                           Copyright  2008, Perky_z | 
//|    http://groups.yahoo.com/group/MetaTrader_Experts_and_Indicators/ | 
//+---------------------------------------------------------------------+ 
//|          SmoothAlgorithms.mqh |
//|   (): __\\MQL5\Include        |
//+---------------------------------------------------------------------+
#property copyright "Copyright  2008, Perky_z"
#property link "http://groups.yahoo.com/group/MetaTrader_Experts_and_Indicators/"
//----   
#property version   "1.00"
//----     
#property indicator_separate_window
//----   
#property indicator_buffers 1 
//----     
#property indicator_plots   1
//+-----------------------------------+
//|       |
//+-----------------------------------+
//----     
#property indicator_type1   DRAW_LINE
//----       DodgerBlue 
#property indicator_color1 clrDodgerBlue
//----   -  
#property indicator_style1  STYLE_SOLID
//----     1
#property indicator_width1  1
//----   
#property indicator_label1  "T3MACO"

//+-----------------------------------+
//|    XMA              |
//+-----------------------------------+
#include <SmoothAlgorithms.mqh> 
//+-----------------------------------+
//----    CMoving_Average  CT3   SmoothAlgorithms.mqh
CT3 T3;
CMoving_Average EMA1,EMA2;
//+-----------------------------------+
//|         |
//+-----------------------------------+
input uint FastEMA=5; //  EMA
input uint SlowEMA=8; //  EMA
input uint T3Length=12;//                     
input int T3Phase=15; // 
input int Shift=0; //      
//+-----------------------------------+

//----   ,    
//      
double T3MACO[];

//----      
int min_rates_,min_rates_total;
//+------------------------------------------------------------------+   
//| T3MACO indicator initialization function                         | 
//+------------------------------------------------------------------+ 
void OnInit()
  {
//----     
   min_rates_=2;
   min_rates_total=min_rates_+1;

//----      
   SetIndexBuffer(0,T3MACO,INDICATOR_DATA);
//----    1  
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//----      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0);

//---           
   IndicatorSetString(INDICATOR_SHORTNAME,"T3MACO");

//---     
   IndicatorSetInteger(INDICATOR_DIGITS,0);
//----  
  }
//+------------------------------------------------------------------+ 
//| T3MACO iteration function                                        | 
//+------------------------------------------------------------------+ 
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]
                )
  {
//----       
   if(rates_total<min_rates_total) return(0);

//----       
   double ema1,ema2;
//----        
   int first,bar;

//----    first    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
      first=0; //      
   else first=prev_calculated-1; //      

//----    
   for(bar=first; bar<rates_total && !IsStopped(); bar++)
     {
      ema1=EMA1.EMASeries(0,prev_calculated,rates_total,FastEMA,close[bar],bar,false);
      ema2=EMA2.EMASeries(0,prev_calculated,rates_total,SlowEMA,open[bar],bar,false);
      T3MACO[bar]=T3.T3Series(1,prev_calculated,rates_total,MODE_T3,T3Phase,T3Length,ema1-ema2,bar,false);
      T3MACO[bar]/=_Point;
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
